AAXtoMP3/AAXtoMP3.sh
Victor Engmark aa93813892 Various tweaks (#16)
* Use lower case variable names

* Extract debug print method

* Split lines

* Simplify looping over parameters

* Use a temporary working directory for safety

* Extract metadata fetching into functions

* Don't replace colon in title

It's in the directory structure anyway.

* Use long ffmpeg options where possible

And use the same options everywhere.

* Don't print debug information during normal script run

* Always read into a dummy variable rather than REPLY

* Use `ffprobe` instead of `ffmpeg` to avoid non-zero exit code

* Handle special characters like single quotes in metadata values

* Stop the program if any errors occur

* Use FD 9 for `while` loop input

* Pass AAX file path to metadata extract command

* Avoid skipping every second file

* Don't check for `ffmpeg`

The script will exit if it's not available.

* Declare function variables local

* Fix whitespace handling

Works with filenames containing single quotes.

* Use variables for reused paths

* Put files in output directory immediately

* Clarify debug output

* Extract codec and extension for simple change

* Encode audiobooks as FLAC

* Put output files with input files

* Remove metadata file between files

* Default codec to MP3; enable FLAC using `--flac`
2017-01-05 17:56:32 -06:00

79 lines
2.2 KiB
Bash
Executable File

#!/usr/bin/env bash
set -o errexit -o noclobber -o nounset -o pipefail
codec=libmp3lame
extension=mp3
if [[ "$1" = '--flac' ]]
then
codec=flac
extension=flac
shift
fi
auth_code=$1
shift
debug() {
echo "$(date "+%F %T%z") ${1}"
}
trap 'rm --recursive --force "${working_directory}"' EXIT
working_directory="$(mktemp --directory)"
metadata_file="${working_directory}/metadata.txt"
save_metadata() {
local media_file
media_file="$1"
ffprobe -i "$media_file" 2> "$metadata_file"
}
get_metadata_value() {
local key
key="$1"
normalize_whitespace "$(grep --max-count=1 --only-matching "${key} *: .*" "$metadata_file" | cut --delimiter=: --fields=2 | sed -e 's#/##g;s/ (Unabridged)//' | tr -s '[:blank:]' ' ')"
}
get_bitrate() {
get_metadata_value bitrate | grep --only-matching '[0-9]\+'
}
normalize_whitespace() {
echo $*
}
for path
do
debug "Decoding ${path} with auth code ${auth_code}..."
save_metadata "${path}"
title=$(get_metadata_value title)
output_directory="$(dirname "${path}")/$(get_metadata_value genre)/$(get_metadata_value artist)/${title}"
mkdir -p "${output_directory}"
full_file_path="${output_directory}/${title}.${extension}"
ffmpeg -loglevel error -stats -activation_bytes "${auth_code}" -i "${path}" -vn -codec:a "${codec}" -ab "$(get_bitrate)k" "${full_file_path}"
debug "Created ${full_file_path}."
debug "Extracting chapter files from ${full_file_path}..."
while read -r -u9 first _ _ start _ end
do
if [[ "${first}" = "Chapter" ]]
then
read -r -u9 _
read -r -u9 _ _ chapter
chapter_file="${output_directory}/${title} - ${chapter}.${extension}"
ffmpeg -loglevel error -stats -i "${full_file_path}" -ss "${start%?}" -to "${end}" -codec:a copy "${chapter_file}"
fi
done 9< "$metadata_file"
debug "Done creating chapters. Single file and chaptered files contained in ${output_directory}."
cover_path="${output_directory}/cover.jpg"
debug "Extracting cover into ${cover_path}..."
ffmpeg -loglevel error -activation_bytes "${auth_code}" -i "${path}" -an -codec:v copy "${cover_path}"
debug "Done."
rm "${metadata_file}"
done